<?php
 
 /**
 * @package Spider Calendar Lite
 * @author Web-Dorado
 * @copyright (C) 2011 Web-Dorado. All rights reserved.
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
require_once( JApplicationHelper::getPath( 'admin_html' ) );
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.
'com_spidercalendar'.DS.'tables');

 $task	= JRequest::getCmd('task'); 
 $id = JRequest::getVar('id', 0, 'get', 'int');
switch($task){
	case 'add':
		addNote();
		break;
		
	case 'cancel';		
		cancelNote();
		break;
		
	case 'save';		
		saveNote();
		break;
	case 'apply':
		applyNote();
		break;
		
	case 'edit':
    	editNote();
    	break;
		
		// This will work when you set task to 'remove
  	case 'remove':
   	 	removeNote();
  		break;
				
   case 'publish':
    	changeNote(1 );
   		break;

   case 'unpublish':
    	changeNote(0 );
    	break;				
	
	default:
		showNote();
		break;

}

//seve note
function saveNote(){
	$mainframe = JFactory::getApplication();
	
	$date=JRequest::getVar( 'date');
	$row =& JTable::getInstance('spidercalendar', 'Table');
	$db =& JFactory::getDBO();
	$query = "SELECT * from #__spidercalendar where date=".$date." and id<>".JRequest::getVar( 'id');
	$db->setQuery( $query );
	$total = $db->loadResult();
	if(count($total)>0)
		$mainframe->redirect('index.php?option=com_spidercalendar', 'This record already exists');
	if(!$row->bind(JRequest::get('post')))
	{
		JError::raiseError(500, $row->getError() );
	}
	$row->date =$date;
	
	if(JRequest::getVar( 'selhour_from'))
	{
	if(JRequest::getVar( 'selhour_to'))
$row->time = JRequest::getVar( 'selhour_from').':'.JRequest::getVar( 'selminute_from').' - '.JRequest::getVar( 'selhour_to').':'.JRequest::getVar( 'selminute_to');
	else
		$row->time = JRequest::getVar( 'selhour_from').':'.JRequest::getVar( 'selminute_from');
	}
	else
	$row->time ="";

	$row->text_for_date = JRequest::getVar( 'text_for_date', '','post', 'string', JREQUEST_ALLOWRAW );
	if(!$row->store()){
		JError::raiseError(500, $row->getError() );
	}
	$mainframe->redirect('index.php?option=com_spidercalendar', 'Message Saved');
}

function applyNote(){
	$mainframe = JFactory::getApplication();
	$row =& JTable::getInstance('spidercalendar', 'Table');
	$date=JRequest::getVar( 'date');
    	$db =& JFactory::getDBO();
	$query = "SELECT * from #__spidercalendar where date=".$date." and id<>".JRequest::getVar( 'id');
	$db->setQuery( $query );
	$total = $db->loadResult();
	if(count($total)>0)
		$mainframe->redirect('index.php?option=com_spidercalendar', 'This record already exists');	
	if(!$row->bind(JRequest::get('post')))
	{
		JError::raiseError(500, $row->getError() );
	}
	$row->date =$date;
	if(JRequest::getVar( 'selhour_from'))
	{
	if(JRequest::getVar( 'selhour_to'))
$row->time = JRequest::getVar( 'selhour_from').':'.JRequest::getVar( 'selminute_from').' - '.JRequest::getVar( 'selhour_to').':'.JRequest::getVar( 'selminute_to');
	else
		$row->time = JRequest::getVar( 'selhour_from').':'.JRequest::getVar( 'selminute_from');
	}
	else
	$row->time ="";
	$row->text_for_date = JRequest::getVar( 'text_for_date', '','post', 'string', JREQUEST_ALLOWRAW );
	if(!$row->store()){
		JError::raiseError(500, $row->getError() );
	}
	$mainframe->redirect('index.php?option=com_spidercalendar&task=edit&cid[]='.$row->id, 'Changes Saved');
}

function addNote(){
	$lists['published'] = JHTML::_('select.booleanlist', 'published' , 'class="inputbox"', 1 );

// display function
	HTML_contact::addNote($lists);
}

function showNote(){
	$option= JRequest::getVar( 'option');
	$mainframe = JFactory::getApplication();
	
    $db =& JFactory::getDBO();
	
	$filter_order= $mainframe->getUserStateFromRequest( $option.'filter_order','filter_order','id','cmd' );
	$filter_order_Dir= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir','','word' );
	$filter_state = $mainframe->getUserStateFromRequest( $option.'filter_state', 	'filter_state', '','word' );
	
	
	$search = $mainframe->getUserStateFromRequest( $option.'search','search','','string' );
	$search = JString::strtolower( $search );
	$limit= $mainframe-> getUserStateFromRequest('global.list.limit',  'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart= $mainframe-> getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	
	$lists = array();
	$where = array();
$lists['search']= $mainframe->getUserStateFromRequest( $option.'search','search','','string' );
$lists['search']= JString::strtolower($lists['search']);
$lists['startdate']= JRequest::getVar('startdate', "");
$lists['enddate']= JRequest::getVar('enddate', "");
if ( $lists['search'] ) {
		$where[] = ' title LIKE "%'.$db->getEscaped($search).'%"';
	}	
 if($lists['startdate']!='')
$where[] ="  `date`>='".$lists['startdate']."' ";
  if($lists['enddate']!='')
$where[] ="  `date`<='".$lists['enddate']."' ";
$filter=( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
	if ($filter_order == 'id'){
		$orderby 	= ' ORDER BY id '. $filter_order_Dir;
	} else {
		$orderby 	= ' ORDER BY '. 
         $filter_order .' '. $filter_order_Dir .', id';
	}	
	
	// get the total number of records
	$query = 'SELECT COUNT(*)'
	. ' FROM #__spidercalendar'
	. $filter
	;
	$db->setQuery( $query );
	$total = $db->loadResult();

	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );	
	
	
	$query = "SELECT * FROM #__spidercalendar  $filter $orderby";
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $db->loadObjectList();
	if($db->getErrorNum()){
		echo $db->stderr();
		return false;
	}
	
	// table ordering
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;	

	// search filter	
        $lists['search']= $search;	
	
    // display function
	HTML_contact::showNote($rows, $pageNav, $lists,$option);
}

//edit note

function editNote()
{
	$db		=& JFactory::getDBO();

	$cid 	= JRequest::getVar('cid', array(0), '', 'array');
	JArrayHelper::toInteger($cid, array(0));
	
	$id 	= $cid[0];

	$row =& JTable::getInstance('spidercalendar', 'Table');
	// load the row from the db table

	$row->load( $id);
	
	$lists = array();
	$lists['published'] = JHTML::_('select.booleanlist', 'published' , 'class="inputbox"', $row->published);

	// display function 
	HTML_contact::editNote($lists, $row);
}

function removeNote()
{

  $mainframe = JFactory::getApplication();
  // Initialize variables	
  $db =& JFactory::getDBO();
  // Define cid array variable
  $cid = JRequest::getVar( 'cid' , array() , '' , 'array' );
  // Make sure cid array variable content integer format
  JArrayHelper::toInteger($cid);

  // If any item selected
  if (count( $cid )) {
    // Prepare sql statement, if cid array more than one, 
    // will be "cid1, cid2, ..."
    $cids = implode( ',', $cid );
    // Create sql statement
    $query = 'DELETE FROM #__spidercalendar'
    . ' WHERE id IN ( '. $cids .' )'
    ;
    // Execute query
    $db->setQuery( $query );
    if (!$db->query()) {
      echo "<script> alert('".$db->getErrorMsg(true)."'); 
      window.history.go(-1); </script>\n";
    }
  }

  // After all, redirect again to frontpage
  $mainframe->redirect( "index.php?option=com_spidercalendar" );
}

function changeNote( $state=0 )
{
  $mainframe = JFactory::getApplication();

  // Initialize variables
  $db 	=& JFactory::getDBO();

  // define variable $cid from GET
  $cid = JRequest::getVar( 'cid' , array() , '' , 'array' );	
  JArrayHelper::toInteger($cid);

  // Check there is/are item that will be changed. 
  //If not, show the error.
  if (count( $cid ) < 1) {
    $action = $state ? 'publish' : 'unpublish';
    JError::raiseError(500, JText::_( 'Select an item 
    to' .$action, true ) );
  }

  // Prepare sql statement, if cid more than one, 
  // it will be "cid1, cid2, cid3, ..."
  $cids = implode( ',', $cid );

  $query = 'UPDATE #__spidercalendar'
  . ' SET published = ' . (int) $state
  . ' WHERE id IN ( '. $cids .' )'
  ;
  // Execute query
  $db->setQuery( $query );
  if (!$db->query()) {
    JError::raiseError(500, $db->getErrorMsg() );
  }

  if (count( $cid ) == 1) {
    $row =& JTable::getInstance('spidercalendar', 'Table');
    $row->checkin( intval( $cid[0] ) );
  }

  // After all, redirect to front page
  $mainframe->redirect( 'index.php?option=com_spidercalendar' );
}

function cancelNote()
{
  $mainframe = JFactory::getApplication();
  $mainframe->redirect( 'index.php?option=com_spidercalendar' );

}

?>